# Prepare an array for the total amount of memory allocated in DSA.
dsa_total_memory = [0] * 40
dsa_total_memory[0] = 1
dsa_total_memory[1] = dsa_total_memory[0] + 1
for i in range(1, 20):
    dsa_memory = 1 << (i)
    dsa_total_memory[i * 2] = dsa_total_memory[(i * 2) - 1] + dsa_memory
    dsa_total_memory[(i * 2) + 1] = dsa_total_memory[i * 2] + dsa_memory
#print(dsa_total_memory)

# The array 'a' has values for maintenance_work_mem, i.e., the threthold. For each value
# in the given array 'a', this function checks the 'ratio'% threthold would work.
def check(a, ratio, verbose):
    ret = True
    for i in a:
        have_ng = False
        mwm = i
        mwm_limit = mwm * ratio
        for dsa in dsa_total_memory:
            if mwm_limit <= dsa:
                # The DSA memory usage exceeded the N% threshold. Check also
                # if it exceeded the maintenance_work_mem too.
                if mwm < dsa:
                    if verbose:
                        print("total=%d %d%%=%d ... FAIL (usage=%d)" % (mwm, ratio * 100, mwm_limit, dsa))
                    ret = False
                    have_ng = True
                break
        if not have_ng and verbose:
            print("all OK (total=%d %d%%=%d)" % (mwm, ratio * 100, mwm_limit))

    return ret

def check_ratio(a, ratio_begin=60, ratio_end=76, ratio_incr=1):
    for ratio in range(ratio_begin, ratio_end, ratio_incr):
        ret = check(a, ratio / 100, False)
        if ret:
            print("ratio %d%% ok" % ratio)
        else:
            print("ratio %d%% FAILED" % ratio)

# power-of-2, such as 1024kB, 2048kB, 4096kB, 8192kB, ...
po2 = []
for i in range(1, 20):
    po2.append(1 << (i + 10))

# from 1024kB(1MB) to 2000MB by 1024
normal_1024 = []
for i in range(1, 2000):
    normal_1024.append(1024 * i)

# from 1024 by 1000
normal_1000 = []
for i in range(1, 2000):
    normal_1000.append(1024 + (1000 * i))

print("test power-of-2")
check_ratio(po2)
print("test normal 1024")
check_ratio(normal_1024)
print("test normal 1000")
check_ratio(normal_1000)
